# Reference
<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

**Classes**

* [`sumo`](#sumo): Configures the Sumo Collector on Windows and Linux

## Classes

### sumo

Configures the Sumo Collector on Windows and Linux

#### Examples

##### Basic usage

```puppet
class { 'sumo': }
```

##### Set the following in the relevant hiera scope:

```puppet

sumo::accessid: lkskj98983hjhj
sumo::accesskey: jlkdlkaldkalkda984nb197jdnkjsomjsdkjiocjJAOSALDJWBDahsikldjkja78
sumo::sumo_package_ver: 19.253-26
sumo::sources_path: "/tmp/sumo-%{osfamily}.json"
```

#### Parameters

The following parameters are available in the `sumo` class.

##### `install`

Data type: `Boolean`

Whether to install and configure the Sumo Logic collector.  It defaults to true, but is implemented so that
the collector can be configured globally, but not installed on nodes in certain Hiera scopes.

##### `accessid`

Data type: `String`

The Sumo Logic collector access ID

##### `accesskey`

Data type: `String`

The Sumo Logic collector access Key

##### `category`

Data type: `Optional[String]`

Source category to use when a source does not specify a category.

##### `clobber`

Data type: `Boolean`

When true, if there is any existing collector with the same name, that collector will be deleted (clobbered).

##### `collector_name`

Data type: `String`

Sets the name of collector used on Sumo Logic. The name can be a maximum of 128 characters.

##### `collector_secure_files`

Data type: `Boolean`

By default, new Collector installations will use Enhanced File System Security.
To disable this feature during installation, set this to false.

##### `collector_url`

Data type: `String`

Sets the URL used to register collector for data collection API.

##### `description`

Data type: `Optional[String]`

Description for the collector to appear in Sumo Logic.

##### `enable_action_source`

Data type: `Boolean`

Script Action Sources are disabled by default. You can enable them by setting this parameter to true.

##### `enable_script_source`

Data type: `Boolean`

Script Sources are disabled by default. You can enable them by setting this parameter to true.

##### `disable_upgrade`

Data type: `Boolean`

If true, the collector rejects upgrade requests from Sumo.

##### `ephemeral`

Data type: `Boolean`

When true, the collector will be deleted after 12 hours of inactivity.

##### `hostname`

Data type: `String`

The host name of the machine on which the collector is running.

##### `local_config_mgmt`

Data type: `Boolean`

Needs yo be false when using ''sources_path'' and true when using ''sync_sources_path''.

##### `proxy_host`

Data type: `Optional[String]`

Sets proxy host when a proxy server is used.

##### `proxy_ntlmdomain`

Data type: `Optional[String]`

Sets proxy NTLM domain when a proxy server is used with NTLM authentication.

##### `proxy_password`

Data type: `Optional[String]`

Sets proxy password when a proxy server is used with authentication.

##### `proxy_port`

Data type: `Optional[String]`

Sets proxy port when a proxy server is used.

##### `proxy_user`

Data type: `Optional[String]`

Sets proxy user when a proxy server is used with authentication.

##### `skip_access_key_removal`

Data type: `Boolean`

If true, it will skip the access key removal from the user.properties file.

##### `skip_registration`

Data type: `Boolean`

Collectors normally register with Sumo Logic during the installation process, but setting this flag to true will skip registration.
This way, the collector is installed as a service that will start and register automatically when next booted or started.

##### `sources_path`

Data type: `Optional[String]`

Specifies a single UTF-8 encoded JSON file, or a folder containing UTF-8 encoded JSON files,
that defines the Sources to configure upon Collector registration. The contents of the file
or files is read upon Collector registration only,
it is not synchronized with the Collector's configuration on an on-going basis.

##### `sync_sources_path`

Data type: `Optional[String]`

Specifies either a single UTF-8 encoded JSON file, or a folder containing UTF-8 encoded JSON
files, that define the Sources to configure upon Collector registration. The Source definitions
will be continuously monitored and synchronized with the Collector's configuration.

##### `target_cpu`

Data type: `Optional[Integer]`

You can choose to set a CPU target to limit the amount of CPU processing a collector uses.
The value must be expressed as a whole number percentage string, e.g. 20.

##### `time_zone`

Data type: `Optional[String]`

The time zone to use when it is not extracted from the log timestamp.

##### `token`

Data type: `Optional[String]`

Sets the Setup Wizard Token, a one-time use token, available for one hour after it is generated,
then it expires. This token authenticates the user. It is designed to be used for only one Collector.
The token cannot be used with the API, and it cannot be disabled.

##### `runas_username`

Data type: `Optional[String]`

When set, the Collector will run as the specified user (Windows and Linux).
For Windows, the user account needs Log on as a Service permission.

##### `win_run_as_password`

Data type: `Optional[String]`

(Windows only) When set in conjunction with runas_username, the Collector will run as the specified user with the specified password.

##### `user_properties_path`

Data type: `String`

Set the absolute path of the user.properties file.  It default to the location in the default install location.

##### `install_properties_path`

Data type: `Optional[String]`

Set this to the location specified in the Chocolatey configuration.  Default is 'C:\windows\temp\sumoVarFile.txt'.

##### `package`

Data type: `Struct[{name => String, version => String}]`

Set the name and version of the package to install

##### `service`

Data type: `Struct[{name => String, running => Boolean, enabled => Boolean}]`

Set the name and state of the collector service

